﻿using System;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace IRaCIS.Core.Domain.Models
{
    [Table("DicomInstance")]
    public class DicomInstance : BaseFullAuditEntity, IEntitySeqId
    {
        #region 导航属性
        [JsonIgnore]
        [ForeignKey("SeriesId")]
        public DicomSeries DicomSerie { get; set; }

        [JsonIgnore]
        [ForeignKey("StudyId")]
        public DicomStudy DicomStudy { get; set; }
        #endregion



        public Guid SeqId { get; set; }
        public Guid StudyId { get; set; }
        public Guid SeriesId { get; set; }
        public string StudyInstanceUid { get; set; } = String.Empty;
        public string SeriesInstanceUid { get; set; } = String.Empty;
        public string SopInstanceUid { get; set; } = String.Empty;
        public int InstanceNumber { get; set; }
        public DateTime? InstanceTime { get; set; }
        public bool CPIStatus { get; set; }
        public int ImageRows { get; set; }
        public int ImageColumns { get; set; }
        public int SliceLocation { get; set; }


        public string SliceThickness { get; set; } = String.Empty;
        public int NumberOfFrames { get; set; }
        public string PixelSpacing { get; set; } = String.Empty;

        public string ImagerPixelSpacing { get; set; } = String.Empty;
        public string FrameOfReferenceUID { get; set; } = String.Empty;
        public string WindowCenter { get; set; } = String.Empty;
        public string WindowWidth { get; set; } = String.Empty;


        public Guid TrialId { get; set; }

        public Guid SubjectId { get; set; }
        public Guid SubjectVisitId { get; set; }
        public bool Anonymize { get; set; }
        public string Path { get; set; } = String.Empty;

        public string HtmlPath { get; set; } = string.Empty;

        public long? FileSize { get; set; }

    }
}
